/* cache.c generated by valac, the Vala compiler
 * generated from cache.vala, do not modify */

/* cache.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <config.h>


#define TYPE_CACHE (cache_get_type ())
#define CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CACHE, Cache))
#define CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CACHE, CacheClass))
#define IS_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CACHE))
#define IS_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CACHE))
#define CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CACHE, CacheClass))

typedef struct _Cache Cache;
typedef struct _CacheClass CacheClass;
typedef struct _CachePrivate CachePrivate;

#define CACHE_TYPE_METHOD (cache_method_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _CacheDownloadAsyncData CacheDownloadAsyncData;

struct _Cache {
	GObject parent_instance;
	CachePrivate * priv;
};

struct _CacheClass {
	GObjectClass parent_class;
};

struct _CachePrivate {
	char* cache_path;
	GeeHashMap* map;
	GRegex* url_re;
};

typedef enum  {
	CACHE_METHOD_SYNC,
	CACHE_METHOD_ASYNC
} CacheMethod;

struct _CacheDownloadAsyncData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Cache* self;
	char* url;
	char* save_name;
	gboolean need_emit;
	GFile* pick;
	char* _tmp0_;
	GFile* _tmp1_;
	GFile* pick_file;
	char* _tmp3_;
	char* _tmp2_;
	GFile* _tmp4_;
	char* _tmp6_;
	char* _tmp5_;
	GError * _inner_error_;
};


static gpointer cache_parent_class = NULL;

GType cache_get_type (void);
#define CACHE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CACHE, CachePrivate))
enum  {
	CACHE_DUMMY_PROPERTY
};
GType cache_method_get_type (void);
static void cache_check_cache_dir (Cache* self);
Cache* cache_new (void);
Cache* cache_construct (GType object_type);
static void cache_download_async (Cache* self, const char* url, const char* save_name, gboolean need_emit, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void cache_download_finish (Cache* self, GAsyncResult* _res_);
static void cache_download (Cache* self, const char* url, const char* save_name);
char* cache_get_or_download (Cache* self, const char* url, CacheMethod method, gboolean need_emit);
static char* cache_encode_url (Cache* self, const char* url);
static void cache_download_async_data_free (gpointer _data);
static void cache_download_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean cache_download_async_co (CacheDownloadAsyncData* data);
void cache_delete_cache (Cache* self);
static void cache_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

GType cache_method_get_type (void) {
	static volatile gsize cache_method_type_id__volatile = 0;
	if (g_once_init_enter (&cache_method_type_id__volatile)) {
		static const GEnumValue values[] = {{CACHE_METHOD_SYNC, "CACHE_METHOD_SYNC", "sync"}, {CACHE_METHOD_ASYNC, "CACHE_METHOD_ASYNC", "async"}, {0, NULL, NULL}};
		GType cache_method_type_id;
		cache_method_type_id = g_enum_register_static ("CacheMethod", values);
		g_once_init_leave (&cache_method_type_id__volatile, cache_method_type_id);
	}
	return cache_method_type_id__volatile;
}


Cache* cache_construct (GType object_type) {
	GError * _inner_error_;
	Cache * self;
	GeeHashMap* _tmp0_;
	GRegex* _tmp1_;
	GRegex* _tmp2_;
	_inner_error_ = NULL;
	self = (Cache*) g_object_new (object_type, NULL);
	self->priv->map = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL), _g_object_unref0 (self->priv->map), _tmp0_);
	cache_check_cache_dir (self);
	_tmp1_ = g_regex_new ("(http://)([a-zA-Z0-9-\\.]+)/(.*)", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	self->priv->url_re = (_tmp2_ = _tmp1_, _g_regex_unref0 (self->priv->url_re), _tmp2_);
	return self;
}


Cache* cache_new (void) {
	return cache_construct (TYPE_CACHE);
}


static char* string_replace (const char* self, const char* old, const char* replacement) {
	char* result = NULL;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch28_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch28_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally28;
	__catch28_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
	}
	__finally28:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


char* cache_get_or_download (Cache* self, const char* url, CacheMethod method, gboolean need_emit) {
	char* result = NULL;
	char* quick_response;
	char* save_name;
	char* _tmp0_;
	char* _tmp1_;
	char* file_path;
	GFile* file;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	quick_response = (char*) gee_abstract_map_get ((GeeAbstractMap*) self->priv->map, url);
	if (quick_response != NULL) {
		result = quick_response;
		return result;
	}
	save_name = string_replace (url, "/", "");
	file_path = (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (self->priv->cache_path, "/", NULL), save_name, NULL), _g_free0 (_tmp0_), _tmp1_);
	file = g_file_new_for_path (file_path);
	if (g_file_query_exists (file, NULL)) {
		gee_abstract_map_set ((GeeAbstractMap*) self->priv->map, url, file_path);
		result = file_path;
		_g_free0 (quick_response);
		_g_free0 (save_name);
		_g_object_unref0 (file);
		return result;
	}
	if (method == CACHE_METHOD_ASYNC) {
		cache_download_async (self, url, save_name, need_emit, NULL, NULL);
		result = g_strdup (url);
		_g_free0 (quick_response);
		_g_free0 (save_name);
		_g_free0 (file_path);
		_g_object_unref0 (file);
		return result;
	}
	cache_download (self, url, save_name);
	result = file_path;
	_g_free0 (quick_response);
	_g_free0 (save_name);
	_g_object_unref0 (file);
	return result;
}


static char* cache_encode_url (Cache* self, const char* url) {
	char* result = NULL;
	GError * _inner_error_;
	char* old_url_path;
	gint _tmp1__length1;
	char** _tmp1_;
	char** _tmp0_;
	char* _tmp2_;
	char* new_url_path;
	char* _tmp3_;
	char* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_inner_error_ = NULL;
	old_url_path = g_regex_replace (self->priv->url_re, url, (gssize) (-1), 0, "\\3", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	new_url_path = (_tmp2_ = g_strdup ((_tmp1_ = _tmp0_ = g_strsplit (soup_form_encode ("", old_url_path, NULL), "=", 0), _tmp1__length1 = _vala_array_length (_tmp0_), _tmp1_)[1]), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp2_);
	new_url_path = (_tmp3_ = string_replace (url, old_url_path, new_url_path), _g_free0 (new_url_path), _tmp3_);
	new_url_path = (_tmp4_ = string_replace (new_url_path, "%2F", "/"), _g_free0 (new_url_path), _tmp4_);
	result = new_url_path;
	_g_free0 (old_url_path);
	return result;
}


static void cache_download (Cache* self, const char* url, const char* save_name) {
	GError * _inner_error_;
	GFile* pick;
	char* _tmp1_;
	char* _tmp0_;
	GFile* _tmp2_;
	GFile* pick_file;
	g_return_if_fail (self != NULL);
	g_return_if_fail (url != NULL);
	g_return_if_fail (save_name != NULL);
	_inner_error_ = NULL;
	pick = g_file_new_for_uri (url);
	pick_file = (_tmp2_ = g_file_new_for_path (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (self->priv->cache_path, "/", NULL), save_name, NULL)), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
	if (!g_file_query_exists (pick_file, NULL)) {
		g_file_copy (pick, pick_file, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (pick);
			_g_object_unref0 (pick_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (pick);
	_g_object_unref0 (pick_file);
}


static void cache_download_async_data_free (gpointer _data) {
	CacheDownloadAsyncData* data;
	data = _data;
	_g_free0 (data->url);
	_g_free0 (data->save_name);
	g_object_unref (data->self);
	g_slice_free (CacheDownloadAsyncData, data);
}


static void cache_download_async (Cache* self, const char* url, const char* save_name, gboolean need_emit, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	CacheDownloadAsyncData* _data_;
	_data_ = g_slice_new0 (CacheDownloadAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, cache_download_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, cache_download_async_data_free);
	_data_->self = g_object_ref (self);
	_data_->url = g_strdup (url);
	_data_->save_name = g_strdup (save_name);
	_data_->need_emit = need_emit;
	cache_download_async_co (_data_);
}


static void cache_download_finish (Cache* self, GAsyncResult* _res_) {
	CacheDownloadAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void cache_download_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	CacheDownloadAsyncData* data;
	data = _user_data_;
	data->_res_ = _res_;
	cache_download_async_co (data);
}


static gboolean cache_download_async_co (CacheDownloadAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		data->pick = (data->_tmp1_ = g_file_new_for_uri (data->_tmp0_ = cache_encode_url (data->self, data->url)), _g_free0 (data->_tmp0_), data->_tmp1_);
		data->pick_file = (data->_tmp4_ = g_file_new_for_path (data->_tmp3_ = g_strconcat (data->_tmp2_ = g_strconcat (data->self->priv->cache_path, "/", NULL), data->save_name, NULL)), _g_free0 (data->_tmp3_), _g_free0 (data->_tmp2_), data->_tmp4_);
		if (!g_file_query_exists (data->pick_file, NULL)) {
			data->_state_ = 1;
			g_file_copy_async (data->pick, data->pick_file, G_FILE_COPY_NONE, 1, NULL, NULL, NULL, cache_download_async_ready, data);
			return FALSE;
			_state_1:
			g_file_copy_finish (data->pick, data->_res_, &data->_inner_error_);
			if (data->_inner_error_ != NULL) {
				_g_object_unref0 (data->pick);
				_g_object_unref0 (data->pick_file);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
				g_clear_error (&data->_inner_error_);
				return FALSE;
			}
		}
		if (data->need_emit) {
			g_signal_emit_by_name (data->self, "pic-downloaded", data->url, data->_tmp6_ = g_strconcat (data->_tmp5_ = g_strconcat (data->self->priv->cache_path, "/", NULL), data->save_name, NULL));
			_g_free0 (data->_tmp6_);
			_g_free0 (data->_tmp5_);
		}
		_g_object_unref0 (data->pick);
		_g_object_unref0 (data->pick_file);
	}
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


static void cache_check_cache_dir (Cache* self) {
	GError * _inner_error_;
	char* _tmp1_;
	char* _tmp0_;
	GFile* cache_dir;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	self->priv->cache_path = (_tmp1_ = g_strconcat (g_get_user_cache_dir (), _tmp0_ = g_strdup_printf ("/%s", APPNAME), NULL), _g_free0 (self->priv->cache_path), _tmp1_);
	_g_free0 (_tmp0_);
	cache_dir = g_file_new_for_path (self->priv->cache_path);
	if (!g_file_query_exists (cache_dir, NULL)) {
		g_file_make_directory (cache_dir, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (cache_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (cache_dir);
}


void cache_delete_cache (Cache* self) {
	GError * _inner_error_;
	GFile* cache_dir;
	GFileEnumerator* en;
	GFileInfo* file_info;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	cache_dir = g_file_new_for_path (self->priv->cache_path);
	en = g_file_enumerate_children (cache_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (cache_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	file_info = NULL;
	while (TRUE) {
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
		char* _tmp3_;
		char* _tmp2_;
		GFile* _tmp4_;
		GFile* d_file;
		_tmp0_ = g_file_enumerator_next_file (en, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (cache_dir);
			_g_object_unref0 (en);
			_g_object_unref0 (file_info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		if (!((file_info = (_tmp1_ = _tmp0_, _g_object_unref0 (file_info), _tmp1_)) != NULL)) {
			break;
		}
		d_file = (_tmp4_ = g_file_new_for_path (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (self->priv->cache_path, "/", NULL), g_file_info_get_name (file_info), NULL)), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _tmp4_);
		g_file_delete (d_file, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (d_file);
			_g_object_unref0 (cache_dir);
			_g_object_unref0 (en);
			_g_object_unref0 (file_info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_object_unref0 (d_file);
	}
	gee_abstract_map_clear ((GeeAbstractMap*) self->priv->map);
	_g_object_unref0 (cache_dir);
	_g_object_unref0 (en);
	_g_object_unref0 (file_info);
}


static void cache_class_init (CacheClass * klass) {
	cache_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CachePrivate));
	G_OBJECT_CLASS (klass)->finalize = cache_finalize;
	g_signal_new ("pic_downloaded", TYPE_CACHE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}


static void cache_instance_init (Cache * self) {
	self->priv = CACHE_GET_PRIVATE (self);
}


static void cache_finalize (GObject* obj) {
	Cache * self;
	self = CACHE (obj);
	_g_free0 (self->priv->cache_path);
	_g_object_unref0 (self->priv->map);
	_g_regex_unref0 (self->priv->url_re);
	G_OBJECT_CLASS (cache_parent_class)->finalize (obj);
}


GType cache_get_type (void) {
	static volatile gsize cache_type_id__volatile = 0;
	if (g_once_init_enter (&cache_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Cache), 0, (GInstanceInitFunc) cache_instance_init, NULL };
		GType cache_type_id;
		cache_type_id = g_type_register_static (G_TYPE_OBJECT, "Cache", &g_define_type_info, 0);
		g_once_init_leave (&cache_type_id__volatile, cache_type_id);
	}
	return cache_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}



