/* color_utils.c generated by valac, the Vala compiler
 * generated from color_utils.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))



char* color_utils_color2rgba (GdkColor* color, double alpha);
void color_utils_rgba2color (const char* rgba, guint16* alpha, GdkColor* result);
char* color_utils_rgb_to_hex (GdkColor* color);
guint16 color_utils_lighter (guint16 color, guint16 delta);
guint16 color_utils_darker (guint16 color, guint16 delta);



static char* double_to_string (double self) {
	char* result = NULL;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
	result = (_tmp1_ = g_strdup (g_ascii_dtostr ((_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE), _tmp0__length1 = G_ASCII_DTOSTR_BUF_SIZE, _tmp0_), G_ASCII_DTOSTR_BUF_SIZE, self)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	return result;
}


static char* string_substring (const char* self, glong offset, glong len) {
	char* result = NULL;
	glong string_length;
	const char* start;
	g_return_val_if_fail (self != NULL, NULL);
	string_length = g_utf8_strlen (self, -1);
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


char* color_utils_color2rgba (GdkColor* color, double alpha) {
	char* result = NULL;
	char* alpha_string;
	GQuark _tmp5_;
	const char* _tmp4_;
	static GQuark _tmp5__label0 = 0;
	static GQuark _tmp5__label1 = 0;
	alpha_string = double_to_string (alpha);
	_tmp4_ = alpha_string;
	_tmp5_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
	if (_tmp5_ == ((0 != _tmp5__label0) ? _tmp5__label0 : (_tmp5__label0 = g_quark_from_static_string ("0"))))
	switch (0) {
		default:
		{
			char* _tmp0_;
			alpha_string = (_tmp0_ = g_strdup ("0.00"), _g_free0 (alpha_string), _tmp0_);
			break;
		}
	} else if (_tmp5_ == ((0 != _tmp5__label1) ? _tmp5__label1 : (_tmp5__label1 = g_quark_from_static_string ("1"))))
	switch (0) {
		default:
		{
			char* _tmp1_;
			alpha_string = (_tmp1_ = g_strdup ("1.00"), _g_free0 (alpha_string), _tmp1_);
			break;
		}
	} else
	switch (0) {
		default:
		{
			char* _tmp3_;
			char* _tmp2_;
			alpha_string = (_tmp3_ = string_substring (_tmp2_ = double_to_string (alpha), (glong) 0, (glong) 4), _g_free0 (alpha_string), _tmp3_);
			_g_free0 (_tmp2_);
			break;
		}
	}
	result = g_strdup_printf ("rgba(%d, %d, %d, %s)", (*color).red / 256, (*color).green / 256, (*color).blue / 256, alpha_string);
	_g_free0 (alpha_string);
	return result;
}


void color_utils_rgba2color (const char* rgba, guint16* alpha, GdkColor* result) {
	GError * _inner_error_;
	GdkColor color = {0};
	GRegex* re;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	g_return_if_fail (rgba != NULL);
	_inner_error_ = NULL;
	memset (&color, 0, sizeof (GdkColor));
	re = g_regex_new ("rgba\\(([0-9]+), ([0-9]+), ([0-9]+), ([0-9]\\.[0-9][0-9])\\)", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp0_ = g_regex_replace (re, rgba, (gssize) (-1), 0, "\\1", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	color.red = (guint16) (((guint16) atoi (_tmp1_ = _tmp0_)) * 256);
	_g_free0 (_tmp1_);
	_tmp2_ = g_regex_replace (re, rgba, (gssize) (-1), 0, "\\2", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	color.green = (guint16) (((guint16) atoi (_tmp3_ = _tmp2_)) * 256);
	_g_free0 (_tmp3_);
	_tmp4_ = g_regex_replace (re, rgba, (gssize) (-1), 0, "\\3", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	color.blue = (guint16) (((guint16) atoi (_tmp5_ = _tmp4_)) * 256);
	_g_free0 (_tmp5_);
	_tmp6_ = g_regex_replace (re, rgba, (gssize) (-1), 0, "\\4", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	*alpha = (guint16) ((g_ascii_strtod (_tmp7_ = _tmp6_, NULL) * 256.0) * 256.0);
	_g_free0 (_tmp7_);
	*result = color;
	_g_regex_unref0 (re);
	return;
}


char* color_utils_rgb_to_hex (GdkColor* color) {
	char* result = NULL;
	char* s;
	s = g_strdup_printf ("%X%X%X", (guint) ((gint) trunc ((*color).red / 256.00)), (guint) ((gint) trunc ((*color).green / 256.00)), (guint) ((gint) trunc ((*color).blue / 256.00)));
	result = g_strconcat ("#", s, NULL);
	_g_free0 (s);
	return result;
}


guint16 color_utils_lighter (guint16 color, guint16 delta) {
	guint16 result = 0U;
	if ((color + delta) > (255 * 256)) {
		result = (guint16) (255 * 256);
		return result;
	} else {
		result = color + delta;
		return result;
	}
}


guint16 color_utils_darker (guint16 color, guint16 delta) {
	guint16 result = 0U;
	if ((color - delta) < 0) {
		result = (guint16) 0;
		return result;
	} else {
		result = color - delta;
		return result;
	}
}




