/* prefs.c generated by valac, the Vala compiler
 * generated from prefs.vala, do not modify */

/* prefs.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gio/gio.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <stdio.h>


#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef struct _PrefsPrivate PrefsPrivate;

#define PREFS_TYPE_LOAD_STATUS (prefs_load_status_get_type ())

#define PREFS_TYPE_WRITE_STATUS (prefs_write_status_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define RE_TWEET_TYPE_STYLE (re_tweet_style_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _Prefs {
	GObject parent_instance;
	PrefsPrivate * priv;
	gboolean is_new;
};

struct _PrefsClass {
	GObjectClass parent_class;
};

struct _PrefsPrivate {
	char* prefFilePath;
	gint _updateInterval;
	gint _numberStatuses;
	char* _urlShorten;
	gboolean _enableSpell;
	gboolean _showTimelineNotify;
	gboolean _showMentionsNotify;
	gboolean _showDirectNotify;
	char* _retweetStyle;
	gboolean _roundedAvatars;
	char* _opacityTweets;
	gboolean _rtlSupport;
	gboolean _fullNames;
	gboolean _nativeLinkColor;
	gint _deFontSize;
	char* _deFontName;
	char* _freshColor;
	gint _width;
	gint _height;
	gint _left;
	gint _top;
	gboolean _menuShow;
	gboolean _toolbarShow;
	gboolean _startMin;
	gboolean _showTray;
};

typedef enum  {
	PREFS_LOAD_STATUS_OK,
	PREFS_LOAD_STATUS_EMPTY,
	PREFS_LOAD_STATUS_ERROR
} PrefsLoadStatus;

typedef enum  {
	PREFS_WRITE_STATUS_OK,
	PREFS_WRITE_STATUS_ERROR
} PrefsWriteStatus;

typedef enum  {
	RE_TWEET_STYLE_CLASSIC,
	RE_TWEET_STYLE_UNI,
	RE_TWEET_STYLE_VIA
} ReTweetStyle;


static gpointer prefs_parent_class = NULL;

GType prefs_get_type (void);
#define PREFS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFS, PrefsPrivate))
enum  {
	PREFS_DUMMY_PROPERTY,
	PREFS_UPDATE_INTERVAL,
	PREFS_NUMBER_STATUSES,
	PREFS_URL_SHORTEN,
	PREFS_ENABLE_SPELL,
	PREFS_SHOW_TIMELINE_NOTIFY,
	PREFS_SHOW_MENTIONS_NOTIFY,
	PREFS_SHOW_DIRECT_NOTIFY,
	PREFS_RETWEET_STYLE,
	PREFS_ROUNDED_AVATARS,
	PREFS_OPACITY_TWEETS,
	PREFS_RTL_SUPPORT,
	PREFS_FULL_NAMES,
	PREFS_NATIVE_LINK_COLOR,
	PREFS_DE_FONT_SIZE,
	PREFS_DE_FONT_NAME,
	PREFS_DE_FONT,
	PREFS_FRESH_COLOR,
	PREFS_WIDTH,
	PREFS_HEIGHT,
	PREFS_LEFT,
	PREFS_TOP,
	PREFS_MENU_SHOW,
	PREFS_TOOLBAR_SHOW,
	PREFS_START_MIN,
	PREFS_SHOW_TRAY
};
GType prefs_load_status_get_type (void);
GType prefs_write_status_get_type (void);
PrefsLoadStatus prefs_load (Prefs* self);
PrefsWriteStatus prefs_write (Prefs* self);
Prefs* prefs_new (void);
Prefs* prefs_construct (GType object_type);
static PrefsLoadStatus prefs_parse (Prefs* self, const char* content);
gint prefs_get_updateInterval (Prefs* self);
void prefs_set_updateInterval (Prefs* self, gint value);
gint prefs_get_numberStatuses (Prefs* self);
void prefs_set_numberStatuses (Prefs* self, gint value);
const char* prefs_get_urlShorten (Prefs* self);
void prefs_set_urlShorten (Prefs* self, const char* value);
gboolean prefs_get_enableSpell (Prefs* self);
void prefs_set_enableSpell (Prefs* self, gboolean value);
gboolean prefs_get_showTimelineNotify (Prefs* self);
void prefs_set_showTimelineNotify (Prefs* self, gboolean value);
gboolean prefs_get_showMentionsNotify (Prefs* self);
void prefs_set_showMentionsNotify (Prefs* self, gboolean value);
gboolean prefs_get_showDirectNotify (Prefs* self);
void prefs_set_showDirectNotify (Prefs* self, gboolean value);
GType re_tweet_style_get_type (void);
ReTweetStyle prefs_get_retweetStyle (Prefs* self);
void prefs_set_retweetStyle (Prefs* self, ReTweetStyle value);
gboolean prefs_get_roundedAvatars (Prefs* self);
void prefs_set_roundedAvatars (Prefs* self, gboolean value);
const char* prefs_get_opacityTweets (Prefs* self);
void prefs_set_opacityTweets (Prefs* self, const char* value);
gboolean prefs_get_rtlSupport (Prefs* self);
void prefs_set_rtlSupport (Prefs* self, gboolean value);
gboolean prefs_get_fullNames (Prefs* self);
void prefs_set_fullNames (Prefs* self, gboolean value);
gboolean prefs_get_nativeLinkColor (Prefs* self);
void prefs_set_nativeLinkColor (Prefs* self, gboolean value);
gint prefs_get_deFontSize (Prefs* self);
const char* prefs_get_deFontName (Prefs* self);
void prefs_set_deFont (Prefs* self, const char* value);
const char* prefs_get_freshColor (Prefs* self);
void prefs_set_freshColor (Prefs* self, const char* value);
gint prefs_get_width (Prefs* self);
void prefs_set_width (Prefs* self, gint value);
gint prefs_get_height (Prefs* self);
void prefs_set_height (Prefs* self, gint value);
gint prefs_get_left (Prefs* self);
void prefs_set_left (Prefs* self, gint value);
gint prefs_get_top (Prefs* self);
void prefs_set_top (Prefs* self, gint value);
gboolean prefs_get_menuShow (Prefs* self);
void prefs_set_menuShow (Prefs* self, gboolean value);
gboolean prefs_get_toolbarShow (Prefs* self);
void prefs_set_toolbarShow (Prefs* self, gboolean value);
gboolean prefs_get_startMin (Prefs* self);
void prefs_set_startMin (Prefs* self, gboolean value);
gboolean prefs_get_showTray (Prefs* self);
void prefs_set_showTray (Prefs* self, gboolean value);
static void prefs_finalize (GObject* obj);
static void prefs_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void prefs_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



GType prefs_load_status_get_type (void) {
	static volatile gsize prefs_load_status_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_load_status_type_id__volatile)) {
		static const GEnumValue values[] = {{PREFS_LOAD_STATUS_OK, "PREFS_LOAD_STATUS_OK", "ok"}, {PREFS_LOAD_STATUS_EMPTY, "PREFS_LOAD_STATUS_EMPTY", "empty"}, {PREFS_LOAD_STATUS_ERROR, "PREFS_LOAD_STATUS_ERROR", "error"}, {0, NULL, NULL}};
		GType prefs_load_status_type_id;
		prefs_load_status_type_id = g_enum_register_static ("PrefsLoadStatus", values);
		g_once_init_leave (&prefs_load_status_type_id__volatile, prefs_load_status_type_id);
	}
	return prefs_load_status_type_id__volatile;
}


GType prefs_write_status_get_type (void) {
	static volatile gsize prefs_write_status_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_write_status_type_id__volatile)) {
		static const GEnumValue values[] = {{PREFS_WRITE_STATUS_OK, "PREFS_WRITE_STATUS_OK", "ok"}, {PREFS_WRITE_STATUS_ERROR, "PREFS_WRITE_STATUS_ERROR", "error"}, {0, NULL, NULL}};
		GType prefs_write_status_type_id;
		prefs_write_status_type_id = g_enum_register_static ("PrefsWriteStatus", values);
		g_once_init_leave (&prefs_write_status_type_id__volatile, prefs_write_status_type_id);
	}
	return prefs_write_status_type_id__volatile;
}


Prefs* prefs_construct (GType object_type) {
	Prefs * self;
	PrefsLoadStatus load_status;
	self = (Prefs*) g_object_new (object_type, NULL);
	load_status = prefs_load (self);
	if (load_status == PREFS_LOAD_STATUS_EMPTY) {
		prefs_write (self);
	}
	return self;
}


Prefs* prefs_new (void) {
	return prefs_construct (TYPE_PREFS);
}


PrefsLoadStatus prefs_load (Prefs* self) {
	PrefsLoadStatus result = 0;
	GError * _inner_error_;
	char* _tmp0_;
	char* _tmp1_;
	char* pino_dir;
	GFile* dir;
	GFile* _tmp2_;
	char* _tmp3_;
	GFile* pref_file;
	char* content;
	g_return_val_if_fail (self != NULL, 0);
	_inner_error_ = NULL;
	pino_dir = (_tmp1_ = g_strconcat (g_get_user_config_dir (), _tmp0_ = g_strdup_printf ("/%s", APPNAME), NULL), _g_free0 (_tmp0_), _tmp1_);
	dir = g_file_new_for_path (pino_dir);
	if (!g_file_query_exists (dir, NULL)) {
		g_file_make_directory (dir, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (pino_dir);
			_g_object_unref0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
	}
	dir = (_tmp2_ = NULL, _g_object_unref0 (dir), _tmp2_);
	self->priv->prefFilePath = (_tmp3_ = g_strconcat (pino_dir, "/settings.xml", NULL), _g_free0 (self->priv->prefFilePath), _tmp3_);
	pref_file = g_file_new_for_path (self->priv->prefFilePath);
	if (!g_file_query_exists (pref_file, NULL)) {
		self->is_new = TRUE;
		result = PREFS_LOAD_STATUS_EMPTY;
		_g_free0 (pino_dir);
		_g_object_unref0 (dir);
		_g_object_unref0 (pref_file);
		return result;
	}
	content = NULL;
	{
		GFileInputStream* _tmp4_;
		GFileInputStream* _tmp5_;
		GDataInputStream* _tmp6_;
		GDataInputStream* stream;
		char* _tmp7_;
		char* _tmp8_;
		_tmp4_ = g_file_read (pref_file, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (pino_dir);
			_g_object_unref0 (dir);
			_g_object_unref0 (pref_file);
			_g_free0 (content);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		stream = (_tmp6_ = g_data_input_stream_new ((GInputStream*) (_tmp5_ = _tmp4_)), _g_object_unref0 (_tmp5_), _tmp6_);
		_tmp7_ = g_data_input_stream_read_until (stream, "", NULL, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (stream);
			_g_free0 (pino_dir);
			_g_object_unref0 (dir);
			_g_object_unref0 (pref_file);
			_g_free0 (content);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		content = (_tmp8_ = _tmp7_, _g_free0 (content), _tmp8_);
		_g_object_unref0 (stream);
	}
	result = prefs_parse (self, content);
	_g_free0 (pino_dir);
	_g_object_unref0 (dir);
	_g_object_unref0 (pref_file);
	_g_free0 (content);
	return result;
}


static gboolean string_to_bool (const char* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (_vala_strcmp0 (self, "true") == 0) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


static PrefsLoadStatus prefs_parse (Prefs* self, const char* content) {
	PrefsLoadStatus result = 0;
	xmlDoc* xmlDoc;
	xmlNode* rootNode;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (content != NULL, 0);
	xmlDoc = xmlParseMemory (content, (gint) strlen (content));
	rootNode = xmlDocGetRootElement (xmlDoc);
	{
		xmlNode* iter;
		iter = rootNode->children;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				GQuark _tmp26_;
				const char* _tmp25_;
				static GQuark _tmp26__label0 = 0;
				static GQuark _tmp26__label1 = 0;
				static GQuark _tmp26__label2 = 0;
				static GQuark _tmp26__label3 = 0;
				static GQuark _tmp26__label4 = 0;
				static GQuark _tmp26__label5 = 0;
				static GQuark _tmp26__label6 = 0;
				static GQuark _tmp26__label7 = 0;
				static GQuark _tmp26__label8 = 0;
				static GQuark _tmp26__label9 = 0;
				static GQuark _tmp26__label10 = 0;
				static GQuark _tmp26__label11 = 0;
				static GQuark _tmp26__label12 = 0;
				static GQuark _tmp26__label13 = 0;
				static GQuark _tmp26__label14 = 0;
				static GQuark _tmp26__label15 = 0;
				static GQuark _tmp26__label16 = 0;
				static GQuark _tmp26__label17 = 0;
				static GQuark _tmp26__label18 = 0;
				static GQuark _tmp26__label19 = 0;
				static GQuark _tmp26__label20 = 0;
				static GQuark _tmp26__label21 = 0;
				static GQuark _tmp26__label22 = 0;
				static GQuark _tmp26__label23 = 0;
				if (!_tmp0_) {
					iter = iter->next;
				}
				_tmp0_ = FALSE;
				if (!(iter != NULL)) {
					break;
				}
				if (iter->type != XML_ELEMENT_NODE) {
					continue;
				}
				_tmp25_ = iter->name;
				_tmp26_ = (NULL == _tmp25_) ? 0 : g_quark_from_string (_tmp25_);
				if (_tmp26_ == ((0 != _tmp26__label0) ? _tmp26__label0 : (_tmp26__label0 = g_quark_from_static_string ("updateInterval"))))
				switch (0) {
					default:
					{
						char* _tmp1_;
						self->priv->_updateInterval = atoi (_tmp1_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp1_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label1) ? _tmp26__label1 : (_tmp26__label1 = g_quark_from_static_string ("numberStatuses"))))
				switch (0) {
					default:
					{
						char* _tmp2_;
						self->priv->_numberStatuses = atoi (_tmp2_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp2_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label2) ? _tmp26__label2 : (_tmp26__label2 = g_quark_from_static_string ("urlShorten"))))
				switch (0) {
					default:
					{
						char* _tmp3_;
						self->priv->_urlShorten = (_tmp3_ = xmlNodeGetContent (iter), _g_free0 (self->priv->_urlShorten), _tmp3_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label3) ? _tmp26__label3 : (_tmp26__label3 = g_quark_from_static_string ("enableSpell"))))
				switch (0) {
					default:
					{
						char* _tmp4_;
						self->priv->_enableSpell = string_to_bool (_tmp4_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp4_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label4) ? _tmp26__label4 : (_tmp26__label4 = g_quark_from_static_string ("showTimelineNotify"))))
				switch (0) {
					default:
					{
						char* _tmp5_;
						self->priv->_showTimelineNotify = string_to_bool (_tmp5_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp5_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label5) ? _tmp26__label5 : (_tmp26__label5 = g_quark_from_static_string ("showMentionsNotify"))))
				switch (0) {
					default:
					{
						char* _tmp6_;
						self->priv->_showMentionsNotify = string_to_bool (_tmp6_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp6_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label6) ? _tmp26__label6 : (_tmp26__label6 = g_quark_from_static_string ("showDirectNotify"))))
				switch (0) {
					default:
					{
						char* _tmp7_;
						self->priv->_showDirectNotify = string_to_bool (_tmp7_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp7_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label7) ? _tmp26__label7 : (_tmp26__label7 = g_quark_from_static_string ("retweetStyle"))))
				switch (0) {
					default:
					{
						char* _tmp8_;
						self->priv->_retweetStyle = (_tmp8_ = xmlNodeGetContent (iter), _g_free0 (self->priv->_retweetStyle), _tmp8_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label8) ? _tmp26__label8 : (_tmp26__label8 = g_quark_from_static_string ("roundedAvatars"))))
				switch (0) {
					default:
					{
						char* _tmp9_;
						self->priv->_roundedAvatars = string_to_bool (_tmp9_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp9_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label9) ? _tmp26__label9 : (_tmp26__label9 = g_quark_from_static_string ("opacityTweets"))))
				switch (0) {
					default:
					{
						char* _tmp10_;
						self->priv->_opacityTweets = (_tmp10_ = xmlNodeGetContent (iter), _g_free0 (self->priv->_opacityTweets), _tmp10_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label10) ? _tmp26__label10 : (_tmp26__label10 = g_quark_from_static_string ("rtlSupport"))))
				switch (0) {
					default:
					{
						char* _tmp11_;
						self->priv->_rtlSupport = string_to_bool (_tmp11_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp11_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label11) ? _tmp26__label11 : (_tmp26__label11 = g_quark_from_static_string ("fullNames"))))
				switch (0) {
					default:
					{
						char* _tmp12_;
						self->priv->_fullNames = string_to_bool (_tmp12_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp12_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label12) ? _tmp26__label12 : (_tmp26__label12 = g_quark_from_static_string ("nativeLinkColor"))))
				switch (0) {
					default:
					{
						char* _tmp13_;
						self->priv->_nativeLinkColor = string_to_bool (_tmp13_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp13_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label13) ? _tmp26__label13 : (_tmp26__label13 = g_quark_from_static_string ("deFontName"))))
				switch (0) {
					default:
					{
						char* _tmp14_;
						self->priv->_deFontName = (_tmp14_ = xmlNodeGetContent (iter), _g_free0 (self->priv->_deFontName), _tmp14_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label14) ? _tmp26__label14 : (_tmp26__label14 = g_quark_from_static_string ("deFontSize"))))
				switch (0) {
					default:
					{
						char* _tmp15_;
						self->priv->_deFontSize = atoi (_tmp15_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp15_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label15) ? _tmp26__label15 : (_tmp26__label15 = g_quark_from_static_string ("freshColor"))))
				switch (0) {
					default:
					{
						char* _tmp16_;
						self->priv->_freshColor = (_tmp16_ = xmlNodeGetContent (iter), _g_free0 (self->priv->_freshColor), _tmp16_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label16) ? _tmp26__label16 : (_tmp26__label16 = g_quark_from_static_string ("width"))))
				switch (0) {
					default:
					{
						char* _tmp17_;
						self->priv->_width = atoi (_tmp17_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp17_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label17) ? _tmp26__label17 : (_tmp26__label17 = g_quark_from_static_string ("height"))))
				switch (0) {
					default:
					{
						char* _tmp18_;
						self->priv->_height = atoi (_tmp18_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp18_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label18) ? _tmp26__label18 : (_tmp26__label18 = g_quark_from_static_string ("left"))))
				switch (0) {
					default:
					{
						char* _tmp19_;
						self->priv->_left = atoi (_tmp19_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp19_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label19) ? _tmp26__label19 : (_tmp26__label19 = g_quark_from_static_string ("top"))))
				switch (0) {
					default:
					{
						char* _tmp20_;
						self->priv->_top = atoi (_tmp20_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp20_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label20) ? _tmp26__label20 : (_tmp26__label20 = g_quark_from_static_string ("menuShow"))))
				switch (0) {
					default:
					{
						char* _tmp21_;
						self->priv->_menuShow = string_to_bool (_tmp21_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp21_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label21) ? _tmp26__label21 : (_tmp26__label21 = g_quark_from_static_string ("toolbarShow"))))
				switch (0) {
					default:
					{
						char* _tmp22_;
						self->priv->_toolbarShow = string_to_bool (_tmp22_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp22_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label22) ? _tmp26__label22 : (_tmp26__label22 = g_quark_from_static_string ("startMin"))))
				switch (0) {
					default:
					{
						char* _tmp23_;
						self->priv->_startMin = string_to_bool (_tmp23_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp23_);
						break;
					}
				} else if (_tmp26_ == ((0 != _tmp26__label23) ? _tmp26__label23 : (_tmp26__label23 = g_quark_from_static_string ("showTray"))))
				switch (0) {
					default:
					{
						char* _tmp24_;
						self->priv->_showTray = string_to_bool (_tmp24_ = xmlNodeGetContent (iter));
						_g_free0 (_tmp24_);
						break;
					}
				}
			}
		}
	}
	result = PREFS_LOAD_STATUS_OK;
	return result;
}


static char* bool_to_string (gboolean self) {
	char* result = NULL;
	if (self) {
		result = g_strdup ("true");
		return result;
	} else {
		result = g_strdup ("false");
		return result;
	}
}


PrefsWriteStatus prefs_write (Prefs* self) {
	PrefsWriteStatus result = 0;
	xmlDoc* xmldoc;
	xmlNs* ns;
	xmlNode* root;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	char* _tmp11_;
	char* _tmp12_;
	char* _tmp13_;
	char* _tmp14_;
	char* _tmp15_;
	char* _tmp16_;
	char* _tmp17_;
	char* _tmp18_;
	FILE* stream;
	g_return_val_if_fail (self != NULL, 0);
	xmldoc = xmlNewDoc ("1.0");
	ns = xmlNewNs (NULL, NULL, NULL);
	ns->type = XML_ELEMENT_NODE;
	root = xmlNewNode (ns, "settings");
	xmlDocSetRootElement (xmldoc, root);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "updateInterval", _tmp0_ = g_strdup_printf ("%i", self->priv->_updateInterval));
	_g_free0 (_tmp0_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "numberStatuses", _tmp1_ = g_strdup_printf ("%i", self->priv->_numberStatuses));
	_g_free0 (_tmp1_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "urlShorten", self->priv->_urlShorten);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "enableSpell", _tmp2_ = bool_to_string (self->priv->_enableSpell));
	_g_free0 (_tmp2_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "showTimelineNotify", _tmp3_ = bool_to_string (self->priv->_showTimelineNotify));
	_g_free0 (_tmp3_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "showMentionsNotify", _tmp4_ = bool_to_string (self->priv->_showMentionsNotify));
	_g_free0 (_tmp4_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "showDirectNotify", _tmp5_ = bool_to_string (self->priv->_showDirectNotify));
	_g_free0 (_tmp5_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "retweetStyle", self->priv->_retweetStyle);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "roundedAvatars", _tmp6_ = bool_to_string (self->priv->_roundedAvatars));
	_g_free0 (_tmp6_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "opacityTweets", self->priv->_opacityTweets);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "rtlSupport", _tmp7_ = bool_to_string (self->priv->_rtlSupport));
	_g_free0 (_tmp7_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "fullNames", _tmp8_ = bool_to_string (self->priv->_fullNames));
	_g_free0 (_tmp8_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "nativeLinkColor", _tmp9_ = bool_to_string (self->priv->_nativeLinkColor));
	_g_free0 (_tmp9_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "deFontName", self->priv->_deFontName);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "deFontSize", _tmp10_ = g_strdup_printf ("%i", self->priv->_deFontSize));
	_g_free0 (_tmp10_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "freshColor", self->priv->_freshColor);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "width", _tmp11_ = g_strdup_printf ("%i", self->priv->_width));
	_g_free0 (_tmp11_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "height", _tmp12_ = g_strdup_printf ("%i", self->priv->_height));
	_g_free0 (_tmp12_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "left", _tmp13_ = g_strdup_printf ("%i", self->priv->_left));
	_g_free0 (_tmp13_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "top", _tmp14_ = g_strdup_printf ("%i", self->priv->_top));
	_g_free0 (_tmp14_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "menuShow", _tmp15_ = bool_to_string (self->priv->_menuShow));
	_g_free0 (_tmp15_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "toolbarShow", _tmp16_ = bool_to_string (self->priv->_toolbarShow));
	_g_free0 (_tmp16_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "startMin", _tmp17_ = bool_to_string (self->priv->_startMin));
	_g_free0 (_tmp17_);
	xmlNodeAddContent (root, "\n");
	xmlNewTextChild (root, ns, "showTray", _tmp18_ = bool_to_string (self->priv->_showTray));
	_g_free0 (_tmp18_);
	xmlNodeAddContent (root, "\n");
	stream = fopen (self->priv->prefFilePath, "w");
	xmlDocDump (stream, xmldoc);
	result = PREFS_WRITE_STATUS_OK;
	_fclose0 (stream);
	return result;
}


gint prefs_get_updateInterval (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_updateInterval;
	return result;
}


void prefs_set_updateInterval (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_updateInterval = value;
	g_object_notify ((GObject *) self, "updateInterval");
}


gint prefs_get_numberStatuses (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_numberStatuses;
	return result;
}


void prefs_set_numberStatuses (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_numberStatuses = value;
	g_object_notify ((GObject *) self, "numberStatuses");
}


const char* prefs_get_urlShorten (Prefs* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_urlShorten;
	return result;
}


void prefs_set_urlShorten (Prefs* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_urlShorten = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_urlShorten), _tmp0_);
	g_object_notify ((GObject *) self, "urlShorten");
}


gboolean prefs_get_enableSpell (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_enableSpell;
	return result;
}


void prefs_set_enableSpell (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_enableSpell = value;
	g_signal_emit_by_name (self, "enable-spell-changed");
	g_object_notify ((GObject *) self, "enableSpell");
}


gboolean prefs_get_showTimelineNotify (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_showTimelineNotify;
	return result;
}


void prefs_set_showTimelineNotify (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_showTimelineNotify = value;
	g_object_notify ((GObject *) self, "showTimelineNotify");
}


gboolean prefs_get_showMentionsNotify (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_showMentionsNotify;
	return result;
}


void prefs_set_showMentionsNotify (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_showMentionsNotify = value;
	g_object_notify ((GObject *) self, "showMentionsNotify");
}


gboolean prefs_get_showDirectNotify (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_showDirectNotify;
	return result;
}


void prefs_set_showDirectNotify (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_showDirectNotify = value;
	g_object_notify ((GObject *) self, "showDirectNotify");
}


ReTweetStyle prefs_get_retweetStyle (Prefs* self) {
	ReTweetStyle result;
	GQuark _tmp1_;
	const char* _tmp0_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_retweetStyle;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("CLASSIC"))))
	switch (0) {
		default:
		{
			result = RE_TWEET_STYLE_CLASSIC;
			return result;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("UNI"))))
	switch (0) {
		default:
		{
			result = RE_TWEET_STYLE_UNI;
			return result;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("VIA"))))
	switch (0) {
		default:
		{
			result = RE_TWEET_STYLE_VIA;
			return result;
		}
	} else
	switch (0) {
		default:
		{
			result = RE_TWEET_STYLE_UNI;
			return result;
		}
	}
}


void prefs_set_retweetStyle (Prefs* self, ReTweetStyle value) {
	g_return_if_fail (self != NULL);
	switch (value) {
		case RE_TWEET_STYLE_CLASSIC:
		{
			char* _tmp2_;
			self->priv->_retweetStyle = (_tmp2_ = g_strdup ("CLASSIC"), _g_free0 (self->priv->_retweetStyle), _tmp2_);
			break;
		}
		case RE_TWEET_STYLE_UNI:
		{
			char* _tmp3_;
			self->priv->_retweetStyle = (_tmp3_ = g_strdup ("UNI"), _g_free0 (self->priv->_retweetStyle), _tmp3_);
			break;
		}
		case RE_TWEET_STYLE_VIA:
		{
			char* _tmp4_;
			self->priv->_retweetStyle = (_tmp4_ = g_strdup ("VIA"), _g_free0 (self->priv->_retweetStyle), _tmp4_);
			break;
		}
		default:
		{
			char* _tmp5_;
			self->priv->_retweetStyle = (_tmp5_ = g_strdup ("UNI"), _g_free0 (self->priv->_retweetStyle), _tmp5_);
			break;
		}
	}
	g_object_notify ((GObject *) self, "retweetStyle");
}


gboolean prefs_get_roundedAvatars (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_roundedAvatars;
	return result;
}


void prefs_set_roundedAvatars (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_roundedAvatars != value) {
		self->priv->_roundedAvatars = value;
		g_signal_emit_by_name (self, "rounded-avatars-changed");
	}
	g_object_notify ((GObject *) self, "roundedAvatars");
}


const char* prefs_get_opacityTweets (Prefs* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_opacityTweets;
	return result;
}


void prefs_set_opacityTweets (Prefs* self, const char* value) {
	g_return_if_fail (self != NULL);
	if (_vala_strcmp0 (self->priv->_opacityTweets, value) != 0) {
		char* _tmp0_;
		self->priv->_opacityTweets = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_opacityTweets), _tmp0_);
		g_signal_emit_by_name (self, "opacity-tweets-changed");
	}
	g_object_notify ((GObject *) self, "opacityTweets");
}


gboolean prefs_get_rtlSupport (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_rtlSupport;
	return result;
}


void prefs_set_rtlSupport (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_rtlSupport != value) {
		self->priv->_rtlSupport = value;
		g_signal_emit_by_name (self, "rtl-changed");
	}
	g_object_notify ((GObject *) self, "rtlSupport");
}


gboolean prefs_get_fullNames (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_fullNames;
	return result;
}


void prefs_set_fullNames (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_fullNames != value) {
		self->priv->_fullNames = value;
		g_signal_emit_by_name (self, "full-names-changed");
	}
	g_object_notify ((GObject *) self, "fullNames");
}


gboolean prefs_get_nativeLinkColor (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_nativeLinkColor;
	return result;
}


void prefs_set_nativeLinkColor (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_nativeLinkColor = value;
	g_signal_emit_by_name (self, "native-link-color-changed");
	g_object_notify ((GObject *) self, "nativeLinkColor");
}


gint prefs_get_deFontSize (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_deFontSize;
	return result;
}


const char* prefs_get_deFontName (Prefs* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_deFontName;
	return result;
}


void prefs_set_deFont (Prefs* self, const char* value) {
	GError * _inner_error_;
	char* _tmp0_;
	GRegex* bold_italic;
	GRegex* re_style;
	GRegex* re_normal;
	char* my_val;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	self->priv->_deFontName = (_tmp0_ = g_strdup (""), _g_free0 (self->priv->_deFontName), _tmp0_);
	bold_italic = g_regex_new ("(.*)(Bold Italic)(.*)", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	re_style = g_regex_new ("([a-zA-Z0-9 _]+) (BoldItalic|Bold|Italic|Medium|Oblique|BoldOblique) (" \
"[0-9]+)", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (bold_italic);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	re_normal = g_regex_new ("([a-zA-Z0-9 _]+) ([0-9]+)", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (bold_italic);
		_g_regex_unref0 (re_style);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	my_val = g_regex_replace (bold_italic, value, (gssize) (-1), 0, "\\1BoldItalic\\3", 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (bold_italic);
		_g_regex_unref0 (re_style);
		_g_regex_unref0 (re_normal);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	if (g_regex_match (re_style, value, 0, NULL)) {
		char* _tmp1_;
		char* _tmp2_;
		char* _tmp3_;
		char* _tmp4_;
		_tmp1_ = g_regex_replace (re_style, my_val, (gssize) (-1), 0, "\\1", 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (bold_italic);
			_g_regex_unref0 (re_style);
			_g_regex_unref0 (re_normal);
			_g_free0 (my_val);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->_deFontName = (_tmp2_ = _tmp1_, _g_free0 (self->priv->_deFontName), _tmp2_);
		_tmp3_ = g_regex_replace (re_style, my_val, (gssize) (-1), 0, "\\3", 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (bold_italic);
			_g_regex_unref0 (re_style);
			_g_regex_unref0 (re_normal);
			_g_free0 (my_val);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->_deFontSize = atoi (_tmp4_ = _tmp3_);
		_g_free0 (_tmp4_);
	} else {
		char* _tmp5_;
		char* _tmp6_;
		char* _tmp7_;
		char* _tmp8_;
		_tmp5_ = g_regex_replace (re_normal, my_val, (gssize) (-1), 0, "\\1", 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (bold_italic);
			_g_regex_unref0 (re_style);
			_g_regex_unref0 (re_normal);
			_g_free0 (my_val);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->_deFontName = (_tmp6_ = _tmp5_, _g_free0 (self->priv->_deFontName), _tmp6_);
		_tmp7_ = g_regex_replace (re_normal, my_val, (gssize) (-1), 0, "\\2", 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (bold_italic);
			_g_regex_unref0 (re_style);
			_g_regex_unref0 (re_normal);
			_g_free0 (my_val);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->_deFontSize = atoi (_tmp8_ = _tmp7_);
		_g_free0 (_tmp8_);
	}
	g_signal_emit_by_name (self, "font-changed");
	_g_regex_unref0 (bold_italic);
	_g_regex_unref0 (re_style);
	_g_regex_unref0 (re_normal);
	_g_free0 (my_val);
	g_object_notify ((GObject *) self, "deFont");
}


const char* prefs_get_freshColor (Prefs* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_freshColor;
	return result;
}


void prefs_set_freshColor (Prefs* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_freshColor = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_freshColor), _tmp0_);
	g_object_notify ((GObject *) self, "freshColor");
}


gint prefs_get_width (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_width;
	return result;
}


void prefs_set_width (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_width = value;
	g_object_notify ((GObject *) self, "width");
}


gint prefs_get_height (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_height;
	return result;
}


void prefs_set_height (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_height = value;
	g_object_notify ((GObject *) self, "height");
}


gint prefs_get_left (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_left;
	return result;
}


void prefs_set_left (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_left = value;
	g_object_notify ((GObject *) self, "left");
}


gint prefs_get_top (Prefs* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_top;
	return result;
}


void prefs_set_top (Prefs* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_top = value;
	g_object_notify ((GObject *) self, "top");
}


gboolean prefs_get_menuShow (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_menuShow;
	return result;
}


void prefs_set_menuShow (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_menuShow = value;
	g_object_notify ((GObject *) self, "menuShow");
}


gboolean prefs_get_toolbarShow (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_toolbarShow;
	return result;
}


void prefs_set_toolbarShow (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_toolbarShow = value;
	g_object_notify ((GObject *) self, "toolbarShow");
}


gboolean prefs_get_startMin (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_startMin;
	return result;
}


void prefs_set_startMin (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_startMin = value;
	g_object_notify ((GObject *) self, "startMin");
}


gboolean prefs_get_showTray (Prefs* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_showTray;
	return result;
}


void prefs_set_showTray (Prefs* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_showTray = value;
	g_signal_emit_by_name (self, "show-tray-changed");
	g_object_notify ((GObject *) self, "showTray");
}


static void prefs_class_init (PrefsClass * klass) {
	prefs_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PrefsPrivate));
	G_OBJECT_CLASS (klass)->get_property = prefs_get_property;
	G_OBJECT_CLASS (klass)->set_property = prefs_set_property;
	G_OBJECT_CLASS (klass)->finalize = prefs_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_UPDATE_INTERVAL, g_param_spec_int ("updateInterval", "updateInterval", "updateInterval", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_NUMBER_STATUSES, g_param_spec_int ("numberStatuses", "numberStatuses", "numberStatuses", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_URL_SHORTEN, g_param_spec_string ("urlShorten", "urlShorten", "urlShorten", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_ENABLE_SPELL, g_param_spec_boolean ("enableSpell", "enableSpell", "enableSpell", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_SHOW_TIMELINE_NOTIFY, g_param_spec_boolean ("showTimelineNotify", "showTimelineNotify", "showTimelineNotify", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_SHOW_MENTIONS_NOTIFY, g_param_spec_boolean ("showMentionsNotify", "showMentionsNotify", "showMentionsNotify", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_SHOW_DIRECT_NOTIFY, g_param_spec_boolean ("showDirectNotify", "showDirectNotify", "showDirectNotify", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_RETWEET_STYLE, g_param_spec_enum ("retweetStyle", "retweetStyle", "retweetStyle", RE_TWEET_TYPE_STYLE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_ROUNDED_AVATARS, g_param_spec_boolean ("roundedAvatars", "roundedAvatars", "roundedAvatars", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_OPACITY_TWEETS, g_param_spec_string ("opacityTweets", "opacityTweets", "opacityTweets", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_RTL_SUPPORT, g_param_spec_boolean ("rtlSupport", "rtlSupport", "rtlSupport", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_FULL_NAMES, g_param_spec_boolean ("fullNames", "fullNames", "fullNames", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_NATIVE_LINK_COLOR, g_param_spec_boolean ("nativeLinkColor", "nativeLinkColor", "nativeLinkColor", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_DE_FONT_SIZE, g_param_spec_int ("deFontSize", "deFontSize", "deFontSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_DE_FONT_NAME, g_param_spec_string ("deFontName", "deFontName", "deFontName", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_DE_FONT, g_param_spec_string ("deFont", "deFont", "deFont", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_FRESH_COLOR, g_param_spec_string ("freshColor", "freshColor", "freshColor", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_HEIGHT, g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_LEFT, g_param_spec_int ("left", "left", "left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_TOP, g_param_spec_int ("top", "top", "top", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_MENU_SHOW, g_param_spec_boolean ("menuShow", "menuShow", "menuShow", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_TOOLBAR_SHOW, g_param_spec_boolean ("toolbarShow", "toolbarShow", "toolbarShow", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_START_MIN, g_param_spec_boolean ("startMin", "startMin", "startMin", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_SHOW_TRAY, g_param_spec_boolean ("showTray", "showTray", "showTray", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("enable_spell_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("rounded_avatars_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("opacity_tweets_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("rtl_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("full_names_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("native_link_color_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("font_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("show_tray_changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void prefs_instance_init (Prefs * self) {
	self->priv = PREFS_GET_PRIVATE (self);
	self->priv->_updateInterval = 5;
	self->priv->_numberStatuses = 20;
	self->priv->_urlShorten = g_strdup ("goo.gl");
	self->priv->_enableSpell = TRUE;
	self->priv->_showTimelineNotify = TRUE;
	self->priv->_showMentionsNotify = TRUE;
	self->priv->_showDirectNotify = TRUE;
	self->priv->_retweetStyle = g_strdup ("UNI");
	self->priv->_roundedAvatars = TRUE;
	self->priv->_opacityTweets = g_strdup ("0.4");
	self->priv->_rtlSupport = FALSE;
	self->priv->_fullNames = FALSE;
	self->priv->_nativeLinkColor = FALSE;
	self->priv->_deFontSize = 9;
	self->priv->_deFontName = g_strdup ("Dejavu Sans");
	self->priv->_freshColor = g_strdup ("rgba(179, 110, 117, 0.32)");
	self->priv->_width = 250;
	self->priv->_height = 500;
	self->priv->_left = -1;
	self->priv->_top = -1;
	self->priv->_menuShow = TRUE;
	self->priv->_toolbarShow = TRUE;
	self->priv->_startMin = FALSE;
	self->priv->_showTray = TRUE;
	self->is_new = FALSE;
}


static void prefs_finalize (GObject* obj) {
	Prefs * self;
	self = PREFS (obj);
	_g_free0 (self->priv->prefFilePath);
	_g_free0 (self->priv->_urlShorten);
	_g_free0 (self->priv->_retweetStyle);
	_g_free0 (self->priv->_opacityTweets);
	_g_free0 (self->priv->_deFontName);
	_g_free0 (self->priv->_freshColor);
	G_OBJECT_CLASS (prefs_parent_class)->finalize (obj);
}


GType prefs_get_type (void) {
	static volatile gsize prefs_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prefs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Prefs), 0, (GInstanceInitFunc) prefs_instance_init, NULL };
		GType prefs_type_id;
		prefs_type_id = g_type_register_static (G_TYPE_OBJECT, "Prefs", &g_define_type_info, 0);
		g_once_init_leave (&prefs_type_id__volatile, prefs_type_id);
	}
	return prefs_type_id__volatile;
}


static void prefs_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Prefs * self;
	self = PREFS (object);
	switch (property_id) {
		case PREFS_UPDATE_INTERVAL:
		g_value_set_int (value, prefs_get_updateInterval (self));
		break;
		case PREFS_NUMBER_STATUSES:
		g_value_set_int (value, prefs_get_numberStatuses (self));
		break;
		case PREFS_URL_SHORTEN:
		g_value_set_string (value, prefs_get_urlShorten (self));
		break;
		case PREFS_ENABLE_SPELL:
		g_value_set_boolean (value, prefs_get_enableSpell (self));
		break;
		case PREFS_SHOW_TIMELINE_NOTIFY:
		g_value_set_boolean (value, prefs_get_showTimelineNotify (self));
		break;
		case PREFS_SHOW_MENTIONS_NOTIFY:
		g_value_set_boolean (value, prefs_get_showMentionsNotify (self));
		break;
		case PREFS_SHOW_DIRECT_NOTIFY:
		g_value_set_boolean (value, prefs_get_showDirectNotify (self));
		break;
		case PREFS_RETWEET_STYLE:
		g_value_set_enum (value, prefs_get_retweetStyle (self));
		break;
		case PREFS_ROUNDED_AVATARS:
		g_value_set_boolean (value, prefs_get_roundedAvatars (self));
		break;
		case PREFS_OPACITY_TWEETS:
		g_value_set_string (value, prefs_get_opacityTweets (self));
		break;
		case PREFS_RTL_SUPPORT:
		g_value_set_boolean (value, prefs_get_rtlSupport (self));
		break;
		case PREFS_FULL_NAMES:
		g_value_set_boolean (value, prefs_get_fullNames (self));
		break;
		case PREFS_NATIVE_LINK_COLOR:
		g_value_set_boolean (value, prefs_get_nativeLinkColor (self));
		break;
		case PREFS_DE_FONT_SIZE:
		g_value_set_int (value, prefs_get_deFontSize (self));
		break;
		case PREFS_DE_FONT_NAME:
		g_value_set_string (value, prefs_get_deFontName (self));
		break;
		case PREFS_FRESH_COLOR:
		g_value_set_string (value, prefs_get_freshColor (self));
		break;
		case PREFS_WIDTH:
		g_value_set_int (value, prefs_get_width (self));
		break;
		case PREFS_HEIGHT:
		g_value_set_int (value, prefs_get_height (self));
		break;
		case PREFS_LEFT:
		g_value_set_int (value, prefs_get_left (self));
		break;
		case PREFS_TOP:
		g_value_set_int (value, prefs_get_top (self));
		break;
		case PREFS_MENU_SHOW:
		g_value_set_boolean (value, prefs_get_menuShow (self));
		break;
		case PREFS_TOOLBAR_SHOW:
		g_value_set_boolean (value, prefs_get_toolbarShow (self));
		break;
		case PREFS_START_MIN:
		g_value_set_boolean (value, prefs_get_startMin (self));
		break;
		case PREFS_SHOW_TRAY:
		g_value_set_boolean (value, prefs_get_showTray (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void prefs_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Prefs * self;
	self = PREFS (object);
	switch (property_id) {
		case PREFS_UPDATE_INTERVAL:
		prefs_set_updateInterval (self, g_value_get_int (value));
		break;
		case PREFS_NUMBER_STATUSES:
		prefs_set_numberStatuses (self, g_value_get_int (value));
		break;
		case PREFS_URL_SHORTEN:
		prefs_set_urlShorten (self, g_value_get_string (value));
		break;
		case PREFS_ENABLE_SPELL:
		prefs_set_enableSpell (self, g_value_get_boolean (value));
		break;
		case PREFS_SHOW_TIMELINE_NOTIFY:
		prefs_set_showTimelineNotify (self, g_value_get_boolean (value));
		break;
		case PREFS_SHOW_MENTIONS_NOTIFY:
		prefs_set_showMentionsNotify (self, g_value_get_boolean (value));
		break;
		case PREFS_SHOW_DIRECT_NOTIFY:
		prefs_set_showDirectNotify (self, g_value_get_boolean (value));
		break;
		case PREFS_RETWEET_STYLE:
		prefs_set_retweetStyle (self, g_value_get_enum (value));
		break;
		case PREFS_ROUNDED_AVATARS:
		prefs_set_roundedAvatars (self, g_value_get_boolean (value));
		break;
		case PREFS_OPACITY_TWEETS:
		prefs_set_opacityTweets (self, g_value_get_string (value));
		break;
		case PREFS_RTL_SUPPORT:
		prefs_set_rtlSupport (self, g_value_get_boolean (value));
		break;
		case PREFS_FULL_NAMES:
		prefs_set_fullNames (self, g_value_get_boolean (value));
		break;
		case PREFS_NATIVE_LINK_COLOR:
		prefs_set_nativeLinkColor (self, g_value_get_boolean (value));
		break;
		case PREFS_DE_FONT:
		prefs_set_deFont (self, g_value_get_string (value));
		break;
		case PREFS_FRESH_COLOR:
		prefs_set_freshColor (self, g_value_get_string (value));
		break;
		case PREFS_WIDTH:
		prefs_set_width (self, g_value_get_int (value));
		break;
		case PREFS_HEIGHT:
		prefs_set_height (self, g_value_get_int (value));
		break;
		case PREFS_LEFT:
		prefs_set_left (self, g_value_get_int (value));
		break;
		case PREFS_TOP:
		prefs_set_top (self, g_value_get_int (value));
		break;
		case PREFS_MENU_SHOW:
		prefs_set_menuShow (self, g_value_get_boolean (value));
		break;
		case PREFS_TOOLBAR_SHOW:
		prefs_set_toolbarShow (self, g_value_get_boolean (value));
		break;
		case PREFS_START_MIN:
		prefs_set_startMin (self, g_value_get_boolean (value));
		break;
		case PREFS_SHOW_TRAY:
		prefs_set_showTray (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




