/* rest_urls.c generated by valac, the Vala compiler
 * generated from rest_urls.vala, do not modify */

/* rest_urls.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define REST_API_TYPE_REST_URLS (rest_api_rest_urls_get_type ())
#define REST_API_REST_URLS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), REST_API_TYPE_REST_URLS, RestAPIRestUrls))
#define REST_API_REST_URLS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), REST_API_TYPE_REST_URLS, RestAPIRestUrlsClass))
#define REST_API_IS_REST_URLS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), REST_API_TYPE_REST_URLS))
#define REST_API_IS_REST_URLS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), REST_API_TYPE_REST_URLS))
#define REST_API_REST_URLS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), REST_API_TYPE_REST_URLS, RestAPIRestUrlsClass))

typedef struct _RestAPIRestUrls RestAPIRestUrls;
typedef struct _RestAPIRestUrlsClass RestAPIRestUrlsClass;
typedef struct _RestAPIRestUrlsPrivate RestAPIRestUrlsPrivate;

#define REST_API_TYPE_SERVICE_TYPE (rest_api_service_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RestAPIRestUrls {
	GObject parent_instance;
	RestAPIRestUrlsPrivate * priv;
};

struct _RestAPIRestUrlsClass {
	GObjectClass parent_class;
};

typedef enum  {
	REST_API_SERVICE_TYPE_TWITTER,
	REST_API_SERVICE_TYPE_IDENTICA,
	REST_API_SERVICE_TYPE_UNKNOWN
} RestAPIServiceType;

struct _RestAPIRestUrlsPrivate {
	RestAPIServiceType stype;
	char* prefix;
};


static gpointer rest_api_rest_urls_parent_class = NULL;

GType rest_api_rest_urls_get_type (void);
GType rest_api_service_type_get_type (void);
#define REST_API_REST_URLS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), REST_API_TYPE_REST_URLS, RestAPIRestUrlsPrivate))
enum  {
	REST_API_REST_URLS_DUMMY_PROPERTY
};
char* rest_api_rest_urls_home (RestAPIRestUrls* self);
char* rest_api_rest_urls_status_update (RestAPIRestUrls* self);
char* rest_api_rest_urls_destroy_status (RestAPIRestUrls* self);
char* rest_api_rest_urls_destroy_direct (RestAPIRestUrls* self);
char* rest_api_rest_urls_direct_new (RestAPIRestUrls* self);
char* rest_api_rest_urls_mentions (RestAPIRestUrls* self);
char* rest_api_rest_urls_direct_in (RestAPIRestUrls* self);
char* rest_api_rest_urls_user (RestAPIRestUrls* self);
char* rest_api_rest_urls_friendship (RestAPIRestUrls* self);
char* rest_api_rest_urls_status (RestAPIRestUrls* self);
char* rest_api_rest_urls_users_timeline (RestAPIRestUrls* self);
char* rest_api_rest_urls_follow_create (RestAPIRestUrls* self);
char* rest_api_rest_urls_follow_destroy (RestAPIRestUrls* self);
char* rest_api_rest_urls_favorites (RestAPIRestUrls* self);
char* rest_api_rest_urls_favorite_create (RestAPIRestUrls* self);
char* rest_api_rest_urls_favorite_destroy (RestAPIRestUrls* self);
void rest_api_rest_urls_set_prefix (RestAPIRestUrls* self, RestAPIServiceType _stype, const char* _prefix);
RestAPIRestUrls* rest_api_rest_urls_new (RestAPIServiceType _stype, const char* _prefix);
RestAPIRestUrls* rest_api_rest_urls_construct (GType object_type, RestAPIServiceType _stype, const char* _prefix);
static void rest_api_rest_urls_finalize (GObject* obj);



char* rest_api_rest_urls_home (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/home_timeline.xml", NULL);
	return result;
}


char* rest_api_rest_urls_status_update (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/update.xml", NULL);
	return result;
}


char* rest_api_rest_urls_destroy_status (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/destroy/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_destroy_direct (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "direct_messages/destroy/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_direct_new (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "direct_messages/new.xml", NULL);
	return result;
}


char* rest_api_rest_urls_mentions (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/mentions.xml", NULL);
	return result;
}


char* rest_api_rest_urls_direct_in (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "direct_messages.xml", NULL);
	return result;
}


char* rest_api_rest_urls_user (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "users/show/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_friendship (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "friendships/show.xml", NULL);
	return result;
}


char* rest_api_rest_urls_status (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/show/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_users_timeline (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "statuses/user_timeline/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_follow_create (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "friendships/create/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_follow_destroy (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "friendships/destroy/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_favorites (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "favorites.xml", NULL);
	return result;
}


char* rest_api_rest_urls_favorite_create (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "favorites/create/%s.xml", NULL);
	return result;
}


char* rest_api_rest_urls_favorite_destroy (RestAPIRestUrls* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strconcat (self->priv->prefix, "favorites/destroy/%s.xml", NULL);
	return result;
}


RestAPIRestUrls* rest_api_rest_urls_construct (GType object_type, RestAPIServiceType _stype, const char* _prefix) {
	RestAPIRestUrls * self;
	g_return_val_if_fail (_prefix != NULL, NULL);
	self = (RestAPIRestUrls*) g_object_new (object_type, NULL);
	rest_api_rest_urls_set_prefix (self, _stype, _prefix);
	return self;
}


RestAPIRestUrls* rest_api_rest_urls_new (RestAPIServiceType _stype, const char* _prefix) {
	return rest_api_rest_urls_construct (REST_API_TYPE_REST_URLS, _stype, _prefix);
}


void rest_api_rest_urls_set_prefix (RestAPIRestUrls* self, RestAPIServiceType _stype, const char* _prefix) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (_prefix != NULL);
	self->priv->stype = _stype;
	switch (_stype) {
		case REST_API_SERVICE_TYPE_TWITTER:
		{
			char* _tmp0_;
			self->priv->prefix = (_tmp0_ = g_strdup ("http://api.twitter.com/"), _g_free0 (self->priv->prefix), _tmp0_);
			break;
		}
		case REST_API_SERVICE_TYPE_IDENTICA:
		{
			char* _tmp1_;
			self->priv->prefix = (_tmp1_ = g_strdup ("http://identi.ca/api/"), _g_free0 (self->priv->prefix), _tmp1_);
			break;
		}
		case REST_API_SERVICE_TYPE_UNKNOWN:
		{
			char* _tmp2_;
			self->priv->prefix = (_tmp2_ = g_strdup (_prefix), _g_free0 (self->priv->prefix), _tmp2_);
			break;
		}
	}
}


static void rest_api_rest_urls_class_init (RestAPIRestUrlsClass * klass) {
	rest_api_rest_urls_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RestAPIRestUrlsPrivate));
	G_OBJECT_CLASS (klass)->finalize = rest_api_rest_urls_finalize;
}


static void rest_api_rest_urls_instance_init (RestAPIRestUrls * self) {
	self->priv = REST_API_REST_URLS_GET_PRIVATE (self);
	self->priv->prefix = g_strdup ("");
}


static void rest_api_rest_urls_finalize (GObject* obj) {
	RestAPIRestUrls * self;
	self = REST_API_REST_URLS (obj);
	_g_free0 (self->priv->prefix);
	G_OBJECT_CLASS (rest_api_rest_urls_parent_class)->finalize (obj);
}


GType rest_api_rest_urls_get_type (void) {
	static volatile gsize rest_api_rest_urls_type_id__volatile = 0;
	if (g_once_init_enter (&rest_api_rest_urls_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RestAPIRestUrlsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rest_api_rest_urls_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RestAPIRestUrls), 0, (GInstanceInitFunc) rest_api_rest_urls_instance_init, NULL };
		GType rest_api_rest_urls_type_id;
		rest_api_rest_urls_type_id = g_type_register_static (G_TYPE_OBJECT, "RestAPIRestUrls", &g_define_type_info, 0);
		g_once_init_leave (&rest_api_rest_urls_type_id__volatile, rest_api_rest_urls_type_id);
	}
	return rest_api_rest_urls_type_id__volatile;
}




