/* time_utils.c generated by valac, the Vala compiler
 * generated from time_utils.vala, do not modify */

/* time_utils.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



void time_utils_get_current_time (struct tm* result);
gint time_utils_tz_delta (struct tm* t);
void time_utils_str_to_time (const char* str, struct tm* result);



static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	localtime_r (&time, &_result_);
	*result = _result_;
	return;
}


void time_utils_get_current_time (struct tm* result) {
	GTimeVal tval = {0};
	struct tm _tmp0_ = {0};
	g_get_current_time (&tval);
	g_get_current_time (&tval);
	*result = (g_time_local ((time_t) tval.tv_sec, &_tmp0_), _tmp0_);
	return;
}


static char* g_time_format (struct tm *self, const char* format) {
	char* result = NULL;
	gchar* _tmp0_;
	gint _buffer_size_;
	gint buffer_length1;
	gchar* buffer;
	g_return_val_if_fail (format != NULL, NULL);
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, _buffer_size_ = buffer_length1, _tmp0_);
	strftime (buffer, buffer_length1, format, &(*self));
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
	return result;
}


static char* string_substring (const char* self, glong offset, glong len) {
	char* result = NULL;
	glong string_length;
	const char* start;
	g_return_val_if_fail (self != NULL, NULL);
	string_length = g_utf8_strlen (self, -1);
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


gint time_utils_tz_delta (struct tm* t) {
	gint result = 0;
	gint xdelta;
	char* sdelta;
	char* _tmp0_;
	char* _tmp1_;
	xdelta = 0;
	sdelta = g_time_format (t, "%z");
	xdelta = xdelta + (atoi (_tmp0_ = string_substring (sdelta, (glong) 1, (glong) 2)) * 3600);
	_g_free0 (_tmp0_);
	xdelta = xdelta + (atoi (_tmp1_ = string_substring (sdelta, (glong) 3, (glong) 2)) * 60);
	_g_free0 (_tmp1_);
	if (g_utf8_get_char (g_utf8_offset_to_pointer (sdelta, 0)) == '-') {
		xdelta = xdelta * (-1);
	}
	result = xdelta;
	_g_free0 (sdelta);
	return result;
}


void time_utils_str_to_time (const char* str, struct tm* result) {
	struct tm tmpTime = {0};
	time_t tt;
	struct tm _tmp0_ = {0};
	struct tm tmp;
	gint delta;
	gint int_t;
	struct tm _tmp1_ = {0};
	g_return_if_fail (str != NULL);
	memset (&tmpTime, 0, sizeof (struct tm));
	strptime (str, "%a %b %d %T +0000 %Y", &tmpTime);
	tt = mktime (&tmpTime);
	tmp = (g_time_local (tt, &_tmp0_), _tmp0_);
	delta = time_utils_tz_delta (&tmp);
	int_t = ((gint) tt) + delta;
	*result = (g_time_local ((time_t) int_t, &_tmp1_), _tmp1_);
	return;
}




