/* timer.c generated by valac, the Vala compiler
 * generated from timer.vala, do not modify */

/* timer.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define TYPE_SMART_TIMER (smart_timer_get_type ())
#define SMART_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SMART_TIMER, SmartTimer))
#define SMART_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SMART_TIMER, SmartTimerClass))
#define IS_SMART_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SMART_TIMER))
#define IS_SMART_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SMART_TIMER))
#define SMART_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SMART_TIMER, SmartTimerClass))

typedef struct _SmartTimer SmartTimer;
typedef struct _SmartTimerClass SmartTimerClass;
typedef struct _SmartTimerPrivate SmartTimerPrivate;

struct _SmartTimer {
	GObject parent_instance;
	SmartTimerPrivate * priv;
};

struct _SmartTimerClass {
	GObjectClass parent_class;
};

struct _SmartTimerPrivate {
	double interval;
	double elapsed;
};


static gpointer smart_timer_parent_class = NULL;

GType smart_timer_get_type (void);
#define SMART_TIMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SMART_TIMER, SmartTimerPrivate))
enum  {
	SMART_TIMER_DUMMY_PROPERTY
};
static gboolean smart_timer_callback (SmartTimer* self);
static gboolean _smart_timer_callback_gsource_func (gpointer self);
SmartTimer* smart_timer_new (guint _interval);
SmartTimer* smart_timer_construct (GType object_type, guint _interval);
void smart_timer_set_interval (SmartTimer* self, double _interval);
static void smart_timer_finalize (GObject* obj);



static gboolean _smart_timer_callback_gsource_func (gpointer self) {
	return smart_timer_callback (self);
}


SmartTimer* smart_timer_construct (GType object_type, guint _interval) {
	SmartTimer * self;
	self = (SmartTimer*) g_object_new (object_type, NULL);
	self->priv->interval = (double) _interval;
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, _smart_timer_callback_gsource_func, g_object_ref (self), g_object_unref);
	return self;
}


SmartTimer* smart_timer_new (guint _interval) {
	return smart_timer_construct (TYPE_SMART_TIMER, _interval);
}


void smart_timer_set_interval (SmartTimer* self, double _interval) {
	g_return_if_fail (self != NULL);
	self->priv->interval = _interval;
	self->priv->elapsed = (double) 0;
}


static gboolean smart_timer_callback (SmartTimer* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->elapsed = self->priv->elapsed + ((double) 60);
	if (self->priv->elapsed >= self->priv->interval) {
		self->priv->elapsed = (double) 0;
		g_signal_emit_by_name (self, "timeout");
	}
	result = TRUE;
	return result;
}


static void smart_timer_class_init (SmartTimerClass * klass) {
	smart_timer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SmartTimerPrivate));
	G_OBJECT_CLASS (klass)->finalize = smart_timer_finalize;
	g_signal_new ("timeout", TYPE_SMART_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void smart_timer_instance_init (SmartTimer * self) {
	self->priv = SMART_TIMER_GET_PRIVATE (self);
	self->priv->elapsed = (double) 0;
}


static void smart_timer_finalize (GObject* obj) {
	SmartTimer * self;
	self = SMART_TIMER (obj);
	G_OBJECT_CLASS (smart_timer_parent_class)->finalize (obj);
}


GType smart_timer_get_type (void) {
	static volatile gsize smart_timer_type_id__volatile = 0;
	if (g_once_init_enter (&smart_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SmartTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) smart_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SmartTimer), 0, (GInstanceInitFunc) smart_timer_instance_init, NULL };
		GType smart_timer_type_id;
		smart_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "SmartTimer", &g_define_type_info, 0);
		g_once_init_leave (&smart_timer_type_id__volatile, smart_timer_type_id);
	}
	return smart_timer_type_id__volatile;
}




